function CSCErr(%err,%index,%str)
{
	if(($Pref::CSC::Verbose::Chat && $Pref::CSC::ShowErrors::Chat) || ($Pref::CSC::Verbose::Console && $Pref::CSC::ShowErrors::Console))
	{
		%pre = getSubStr(%str,0,%index);
		%ch = getSubStr(%str,%index,1);
		%post = getSubStr(%str,%index + 1,strlen(%str));
		if(strLen(%pre) > 16)
		{
			%pre = "[...]" @ getSubStr(%pre,strLen(%pre) - 12,12);
		}
		if(strLen(%post) > 16)
		{
			%post = getSubStr(%post,0,12) @ "[...]";
		}
	}
	if($Pref::CSC::ShowErrors::Chat)
	{
		NewChatSO.addLine("Parse error\c7 :" SPC %err SPC "@" @ %index);
		if($Pref::CSC::Verbose::Chat)
		{
			NewChatSO.addLine("\c7 " @ %pre @ "\c0" @ %ch @ "\c7" @ %post);
		}
	}
	if($Pref::CSC::ShowErrors::Console)
	{
		echo("\c2Parse error\c0 :" SPC %err SPC "@" @ %index);
		if($Pref::CSC::Verbose::Console)
		{
			echo("" @ %pre @ "\c2#" @ %ch @ "#\c0" @ %post);
		}
	}
}

function NMH_Type::parseServerCmd(%this)
{
	%con = %this.getValue();
	if(getSubStr(%con,0,1) !$= "/")
	{
		return false;
	}

	%escapeables = "\"";

	%command = getSubStr(getWord(%con,0),1,strlen(%con));
	%con = getWords(%con,1);
	for(%i=0;%i<strLen(%con);%i++)
	{
		%ch = getSubStr(%con,%i,1);
		if(%ch $= "\\")
		{
			if(strLen(%con) > %i + 1)
			{
				%nc = getSubStr(%con,%i + 1,1);
				if(strPos(%escapeables,%nc) != -1)
				{
					%buffer = %buffer @ %nc;
					%numskipped++;
					%i++;
				} else {
					%buffer = %buffer @ "\\";
				}
				continue;
			} else {
				%buffer = %buffer @ "\\";
			}
		} else if(%ch $= " " && %inStr == 0)
		{
			%args = (%args $= "" ? expandEscape(%buffer) : %args TAB expandEscape(%buffer));
			%numskipped = 0;
			%buffer = "";
			continue;
		} else if(%ch $= "\"")
		{
			%inStr = !%inStr;
			if(%inStr == 0)
			{
				if(strLen(%con) > %i + 1)
				{
					if(getSubStr(%con,%i + 1,1) !$= " ")
					{
						CSCerr("Quote must be at end of word",%i,%con);
						return false;
					}
				}
			} else {
				if(%i != 0)
				{
					if(getSubStr(%con,%i - 1,1) !$= " ")
					{
						CSCerr("Quote must be at beginning of word",%i,%con);
						return false;
					}
				}
			}
		} else {
			%buffer = %buffer @ %ch;
		}
	}
	if(%inStr)
	{
		CSCerr("Orphaned quote",%i,%con);
		return false;
	}
	if(%buffer !$= "")
	{
		%args = (%args $= "" ? expandEscape(%buffer) : %args TAB expandEscape(%buffer));
	}
	%args = filterServerCmdArgs(%command,%args);
	%str = "commandToServer('" @ %command @ "'";
	for(%i=0;%i<getFieldCount(%args);%i++)
	{
		%str = %str @ ",\"" @ getField(%args,%i) @ "\"";
	}
	%str = %str @ ");";
	eval(%str);
	return true;
}
package CustomServerCmds
{
	function NMH_Type::send(%this)
	{
		%con = %this.getValue();
		if(getSubStr(%con,0,1) $= "/")
		{
			%this.parseServerCmd();
			%this.setValue("");
			canvas.popDialog(NewMessageHud);
		} else {
			Parent::send(%this);
		}
	}
};
activatePackage(CustomServerCmds);


function filterServerCmdArgs(%command,%args)
{
	if(isFunction($RegisteredCallback[%command]))
	{
		return call($RegisteredCallback[%command],%args);
	} else {
		return %args;
	}
}

$RegisteredCallback["kick"] = "getClientID";
$RegisteredCallback["ban"] = "filterBan";

function getClientID(%str)
{
	if(%str >= 100)
	{
		// It's a BL_ID probably who cares
		for(%i=0;%i<NPL_List.rowCount();%i++)
		{
			%row = NPL_List.getRowText(%i);
			if(getField(%row,3) $= %str)
			{
				return NPL_List.getRowID(%i);
			}
		}
	} else {
		%pc = 0;
		for(%i=0;%i<NPL_List.rowCount();%i++)
		{
			%row = NPL_List.getRowText(%i);
			%n = getField(%row,1);
			if(striPos(%n,%str) == 0)
			{
				%p[%pc] = %n;
				%pi[%pc] = NPL_List.getRowID(%i);
				%pc++;
			}
		}
		if(%pc == 1)
		{
			return %pi[0];
		} else if(%pc == 0)
		{
			return 0;
		} else {
			NewChatSO.addLine("\c6Did you mean:");
			%names = "\c3" @ %p[0];
			for(%i=1;%i<%pc;%i++)
			{
				%names = %names @ "\c6, \c3" @ %p[%i];
			}
			NewChatSO.addLine(%names);
			return 0;
		}
	}
}

function filterBan(%str)
{
	%id = getField(%str,0);
	%time = getField(%str,1);
	%reason = getField(%str,2);
	%cid = getClientID(%id);
	if(%cid == 0)
	{
		return 0 TAB %id TAB %time TAB %reason;
	} else {
		return 0 TAB getField(NPL_List.getRowTextByID(%cid),3) TAB %time TAB %reason;
	}
}